
package be.dc.aop.testing;

/** implement double-dispatch using aspects */
public aspect DoubleDispatchDisplayElements {
    public void GraphicalElement.displayOn(Screen screen) {
        screen.display(this);
    }
    
    void around (Screen screen, GraphicalElement graphicalElement): 
        !withincode(void GraphicalElement.displayOn(Screen)) &&
        target (screen) && 
        call (void display(GraphicalElement)) &&
        args (graphicalElement) {
        graphicalElement.displayOn(screen);
    }

    // these could be in separate aspects

    public void Line.displayOn(Screen screen) {
        screen.display(this);
    }
    public void Point.displayOn(Screen screen) {
        screen.display(this);
    }
}
