package be.dc.aop.testing;

import java.util.*;

public aspect GraphicalElementObserverAspect {
	pointcut changes (GraphicalElement graphicalElement):
		target (graphicalElement) &&
		call (void set*(int));
	after (GraphicalElement graphicalElement): changes (graphicalElement) {
	   Iterator observerVisitor 
           = GraphicalElementObserver.getObserversOf (graphicalElement).iterator();
	   while (observerVisitor.hasNext ()) {
		  updateObserver (graphicalElement, (Screen) observerVisitor.next ());
	   }
	}

	private static void updateObserver (GraphicalElement graphicalElement, Screen s) {
        s.display (graphicalElement);
	}
}
